Compare commits

..

No commits in common. "master" and "1.5.0" have entirely different histories.

3 changed files with 73 additions and 219 deletions

View File

@ -4,7 +4,7 @@ sx-open is an attempt to implement a saner alternative to xdg-open.
## Installation ## Installation
Clone the repo, drop sx-open.cfg into your $HOME/.config and set it up to do what you want. There are no built-in defaults, it's all in the config. Clone the repo, drop sx-open.cfg into your $HOME/.config.
As this thing is meant to replace xdg-open, you will probably want to link sx-open into xdg-open somewhere in your $PATH as to override the default one. As this thing is meant to replace xdg-open, you will probably want to link sx-open into xdg-open somewhere in your $PATH as to override the default one.
## Usage ## Usage

247
sx-open
View File

@ -1,204 +1,84 @@
#!/usr/bin/env bash #!/usr/bin/env bash
# This is an attempt to replace xdg-open with something sane. # This is an attempt to replace xdg-open with something sane.
usage() { printf '%s [-dhv] <uri/file>\n' "${0##*/}"; }
usage() { usage() {
cat <<- EOF cat <<- EOF
sx-open [-dhv] <uri/file> sx-open [-dhv] <uri/file>
Flags: Flags:
-d Dry run -d Dry run
-v Verbose mode -v Verbose
-n Disable desktop notifications
-h Help -h Help
EOF EOF
} }
act() { act() {
cfg verbose && printf 'CMD: %s\n' "$*" >&2 (( verbose )) && printf 'CMD: %s\n' "$*" >&2
cfg dryrun || { "$@"; return $?; } (( dry_run )) || { "$@"; return $?; }
return 0 return 0
} }
urldecode() { : "${*//+/ }"; printf '%b\n' "${_//%/\\x}"; } # handle_uri <res> <uri>
# cfg foo bool = [true|1]
# cfg foo [string] = 'bar'
# cfg foo
cfg() {
declare s_name=$1; shift
declare -n \
_s="cfg[$s_name]" \
_s_type="cfg[${s_name}_type]"
if (( $# )); then
while (( $# )); do
case $1 in
(bool|str) _s_type="$1";;
(true|false|0|1)
_s_type='bool'
_s="$1"
break
;;
(=)
[[ $_s_type ]] || _s_type='string'
[[ $_s_type == 'bool' ]] && {
case $2 in
(true|false|0|1) true;;
(*)
error "On line $LINENO, in $FUNCNAME: Invalid value for '$s_name' type 'bool': '$2'"
exit 111
;;
esac
}
_s="$2"
break
;;
(*)
error "On line $LINENO, in $FUNCNAME: Syntax error: “cfg $s_name $*”"
exit 115
;;
esac
shift
done
else
[[ -n $_s ]] || {
error "On line $LINENO, in $FUNCNAME: invalid option: '$s_name'"
exit 113
}
case $_s_type in
(bool)
case $_s in
(true|1) return 0;;
(false|0) return 1;;
esac
;;
(*)
printf '%s\n' "$_s"
return 0
;;
esac
fi
}
notify() {
cfg notify || return 7 # disabled
[[ $DISPLAY ]] || return 3
[[ $notifier ]] || return 5
"${notifier[@]}" 'sx-open' "$@"
}
error() {
printf '%s\n' "$*" >&2
notify "$*"
}
# handle_target <res> <uri>
# 1: cmd failed # 1: cmd failed
# 3: no handler # 3: no handler
handle_target() { handle_uri() {
declare -n result=$1 declare -n result=$1
declare h cmd regex target_is_file target target_left cmd_is_template declare h cmd regex target=$2
cmd_append_target=1
match=0
target=$2
target_left=$target
if [[ -e "$target" ]]; then for h in "${uri_handlers[@]}"; do
target_is_file=1 IFS='=' read cmd regex <<< "$h"
[[ "$target" =~ ^/.* ]] || { target="${PWD}/${target}"; } # Turn relative paths to absolute ones. if [[ "$target" =~ ${regex} ]]; then
act ${cmd} "$target"; result=$?
IFS=';' read target_mimetype _ <<< $( file -ib "$target" )
target_left=$target_mimetype
[[ $target_mimetype == 'inode/symlink' ]] && \
IFS=';' read target_mimetype_true _ <<< $( file -ibL "$target" )
set -- "${mime_handlers[@]}"
elif is_uri "$target"; then
set -- "${uri_handlers[@]}"
else
return 2
fi
while (( $# )); do
cmd_str=$1 regex=$2
cmd=()
# Fix the regex
[[ $regex =~ \^?([^\$]+)\$? ]] && regex="^${BASH_REMATCH[1]}$"
if [[ $cmd_str == *'%target%'* ]]; then
cmd=( ${cmd_str//%target%/$target} )
else
cmd=( $cmd_str "$target" )
fi
if [[ $target_left =~ $regex ]]; then
match=1
elif [[ $target_mimetype_true ]]; then
[[ $target_mimetype_true =~ $regex ]] && match=1
fi
if (( match )); then
act "${cmd[@]}"; result=$?
(( result )) && return 1 (( result )) && return 1
return 0 return 0
fi fi
done
shift 2 return 3
}
# handle_file <res> <file>
# 1: cmd failed
# 2: no such file
# 3: no handler
handle_file() {
declare -n result=$1
declare m \
target_mimetype charset \
cmd regex \
target=$2
[[ -e "$target" ]] || return 3
IFS=';' read target_mimetype charset <<< $( file -ib "$target" )
for m in "${mime_handlers[@]}"; do
IFS='=' read cmd regex <<< "$m"
if [[ "$target_mimetype" =~ ${regex} ]]; then
act ${cmd} "$target"; result=$?
(( result )) && return 1
return 0
fi
done done
return 3 return 3
} }
# DSL # DSL
uri() { uri() { uri_handlers+=( "$1=$2" ); }
declare r handler=$1; shift mime() { mime_handlers+=( "$1=$2" ); }
for r in "$@"; do
uri_handlers+=( "$handler" "$r" )
done
}
mime() {
declare r handler=$1; shift
for r in "$@"; do
mime_handlers+=( "$handler" "$r" )
done
}
scheme() {
declare r handler=$1; shift
for s in "$@"; do
uri_handlers+=( "$handler" "$s:.+" )
done
}
is_uri() [[ $1 =~ ^[a-zA-Z][a-zA-Z0-9\+\.\-]+:.+ ]] is_uri() [[ $1 =~ ^[a-zA-Z][a-zA-Z0-9\+\.\-]+:.+ ]]
main() { main() {
declare cmd_result target declare cmd_result target
declare -gA cfg
cfg verbose bool = false
cfg dryrun bool = false
cfg notify bool = true
# Source the config file. # Source the config file.
cfg_file="$HOME/.config/sx-open.cfg" cfg_file="$HOME/.config/sx-open.cfg"
[[ -f "$cfg_file" ]] && { source "$cfg_file"; } [[ -f "$cfg_file" ]] && { source "$cfg_file"; }
@ -206,15 +86,16 @@ main() {
while (( $# )); do while (( $# )); do
case $1 in case $1 in
(-d) (-d)
cfg dryrun = true printf 'Dry run: not actually running the handler\n' >&2
cfg verbose = true
dry_run=1
verbose=1
;; ;;
(-v) cfg verbose = true;;
(-n) cfg notify = false;; # disable desktop notifications
(-h) usage; return 0;; (-h) usage; return 0;;
(-v) verbose=1;;
(--) shift; break;; (--) shift; break;;
(*) break;; (*) break;;
esac esac
@ -222,38 +103,32 @@ main() {
shift shift
done done
target=$1; [[ "$target" ]] || { usage; exit; } target=$1
# target=$(urldecode "$target") # No idea why I thought this was necessary.
cfg dryrun && { [[ "$target" ]] || { usage; exit; }
printf 'Dry run: not actually running the handler\n' >&2
cfg verbose true
}
# Treat file:// as local paths. # Treat file:// as local paths.
[[ "$target" =~ ^file:(//)?(/.+) ]] && target=${BASH_REMATCH[2]} [[ "$target" =~ ^file:(//)?(/.+) ]] && target=${BASH_REMATCH[2]}
# Figure out if we're in X and set $notifier if we are. if [[ -e "$target" ]]; then
if [[ $DISPLAY ]]; then [[ "$target" =~ ^/.* ]] || { target="${PWD}/${target}"; } # Turn relative paths to absolute ones.
# Do we have notify-send?
notifier=$(type -P 'notify-send')
fi
handle_target cmd_result "$target" handle_file cmd_result "$target"
elif is_uri "$target"; then
handle_uri cmd_result "$target"
else
printf 'No such file or directory: %s\n' "$target" >&2
return 2
fi
case $? in case $? in
(1) (1)
error "Action on “$target” failed with exit code: “$cmd_result”" printf 'Action failed with exit code: %s\n' "$cmd_result" >&2
return 4 return 4
;; ;;
(2)
error "No such file or directory: “$target”"
return 2
;;
(3) (3)
error "No handlers found for “$target”" printf 'No handlers found\n' >&2
return 3 return 3
;; ;;
esac esac

View File

@ -1,33 +1,12 @@
#!syntax bash #!syntax bash
# Configuration file for sx-open # Configuration file for sx-open
# Note that as sx-open checks the regexes in order, they should be placed in order from specific to less so. # Note that as sx-open checks the regexes in order, they should be placed in order from specific to less so.
# Regexes imply '^$' # Format: type cmd regex
# Disable desktop notifications # Examples:
#cfg notify false
# Enable verbose mode #uri browser '^https?:'
#cfg verbose true #uri steam '^steam:'
# Enable dry run mode (implies verbose) #mime sxiv '^image/'
#cfg dryrun true #mime libreoffice '^application/msword$'
# <cmd> macros:
# %target% — The first argument to this script.
# If not found, target is appended to the end of <cmd>
# example:
#uri 'browser %target% --profile=work' 'https://.+\.?workdomain\.tld\..*'
# scheme <cmd> <scheme>[ <scheme> ...]
#scheme browser http https
#scheme steam steam
# Or you can specify a regex for the entire uri:
# uri <cmd> <regex>[ <regex> ...]
#uri steam 'steam:.+'
#uri browser '(https?|ftp):.+'
# Mime types for filesystem targets:
# mime <cmd> <regex>[ <regex> ...]
#mime sxiv 'image/.+'
#mime libreoffice 'application/msword'